#!/usr/local/bin/python

import copy
import random
import os
import sepbase
import tempfile
import time
import unittest
import math
import subprocess
import numpy as np
from numpy.linalg import inv
from batch_task_executor import *
import pbs_util
from main_functions3d import *
from inversion3d import *
from source_inversion import *
from modeled_data3d import *
from born3d import *


# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

if __name__ == '__main__':
    print "Run BatchTaskExecutor_test with params:", sys.argv
    # Check basic environment variable setup.
    assert 'SEP' in os.environ, '!Environment var SEP is not set yet, should have your seplib enviroment set up first! Check paths like /opt/SEP/'
    assert 'RSF' in os.environ, '!Environment var RSF is not set yet, should have your RSF environment set up first! Check paths like /opt/RSF'
    eq_args_from_cmdline, args = sepbase.parse_args(sys.argv)
    param_reader = pbs_util.JobParamReader(eq_args_from_cmdline)

    #------ INITIALIZE SOME STUFF ----------------------
    dict_args = param_reader.dict_args
    # dpIncrease=1.25
    # Ntries = 15
    debug = True

    inversionname = param_reader.dict_args['inversionname']
    rtm_path = param_reader.dict_args['rtm_path']
    pathtemp = param_reader.dict_args['pathtemp']
    wavelet  = param_reader.dict_args['wavelet']
    obs_path = param_reader.dict_args['obs_path']
    syn_path="%s/junksyndata.h" % (pathtemp)
    migvel = param_reader.dict_args['migvel']
    param_reader.dict_args['vel_path'] = migvel

    phigrad = param_reader.dict_args['phigrad']
    tomograd = param_reader.dict_args['tomograd']
    pathtemphess = param_reader.dict_args['pathtemphess']
    param_reader.dict_args['hess_out_path'] = 'junk'

    # INITIALIZING THE MAIN FUNCTION SPACES. FUNCTIONS THAT CALL OTHER FUNCTIONS RELY ON THESE OBJECT INSTANCES
    main = MAIN_FUNCTIONS(param_reader)
    wave_modeling = make_MODELED_DATA(param_reader)
    born_modeling =make_BORN(param_reader)
    souInv=SOURCE_INVERSION(param_reader,'sourceInv')


    print("###################################################################################################")
    print("########################      RTM Imaging   #######################################################")
    print("###################################################################################################")

    # #------- DO SOURCE INVERSION -------------------------------------------------
    # souInv.souInvMAIN(param_reader, True, wavelet, obs_path)


    #------- MAKE SYNTHETIC DATA -------------------------------------------------
    wave_modeling.MODELED_DATA(param_reader, debug,"syndata_MAIN", False, True, migvel, False, wavelet, syn_path)
    # main.residual(debug, syn_path, obs_path, res_path)


    print("====================================================================================")
    print("     MAKING RTM")
    gradtag = 'RTM_image'
    born_modeling.BORN_run(param_reader, gradtag, False, debug, True, inversionname, obs_path)









