# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
#
#   PROGRAM GRABS NODE GATHERS AND DOES PROCESSING ON THEM
#
# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


#!/usr/local/bin/python
import sys
import os
import math
import commands
import sepbase
import sep2npy
import numpy as np


# Read the inputs
if len(sys.argv) < 2:
    print('Error: Not enough input args')
    sys.exit()
recfile = sys.argv[1]
synfile = sys.argv[2]
obsfile = sys.argv[3]
writepath = sys.argv[4]
outputFileName = sys.argv[5]
smallNum=0.000000000001
ntraces=sepbase.get_sep_his_par(synfile,'n2')

cmd1="less %s | wc -l" % (recfile)
stat1,numNodes=commands.getstatusoutput(cmd1)
recList = list(open(recfile))


# Visit each location to grab the binned shot data
for ii in range(1,int(numNodes)):
# for ii in range(0,10):

    print("----------------------------------------")
    percent=100.0*ii/float(numNodes)
    percentcmd="percent done:  %f " % (percent)
    print(percentcmd)

    nodeId=int(str(recList[ii]).split()[0])
    filtname="%s/filter_%d.H" % (writepath,nodeId)
    synNode="%s/synNode_%d.H" % (writepath,nodeId)
    obsNode="%s/obsNode_%d.H" % (writepath,nodeId)

    # Window out the node gather
    w1="Window_key synch=1 key1='nodeId' mink1=%d maxk1=%d < %s > %s hff=%s@@" % (nodeId,nodeId,synfile,synNode,synNode)
    w2="Window_key synch=1 key1='nodeId' mink1=%d maxk1=%d < %s > %s hff=%s@@" % (nodeId,nodeId,obsfile,obsNode,obsNode)
    cmdW="%s; %s" % (w1,w2)
    print(cmdW)
    commands.getstatusoutput(cmdW)

    # Make filter
    f3="< %s Rtoc | Pad n1out=0 | Ft3d sign1=-1 center1=0 > %s/syn_fft%d.H" % (synNode,writepath,nodeId)
    f4="< %s Rtoc | Pad n1out=0 | Ft3d sign1=-1 center1=0 > %s/obs_fft%d.H" % (obsNode,writepath,nodeId)
    f5="Math file1=%s/syn_fft%d.H file2=%s/obs_fft%d.H exp_real='(file1.re*file2.re+file1.im*file2.im)' exp_imag='(file1.im*file2.re-file1.re*file2.im)' | Stack3d maxsize=10000 > junk_numerator.H" % (writepath,nodeId,writepath,nodeId)
    f6="Math file1=%s/obs_fft%d.H file2=%s/obs_fft%d.H exp_real='(file2.re*file2.re+file2.im*file2.im+%f)' exp_imag='file2.im*0.0' | Stack3d maxsize=10000 > junk_denom.H"  % (writepath,nodeId,writepath,nodeId,smallNum)
    f7="Math file1=junk_numerator.H file2=junk_denom.H exp_real='file1.re/file2.re' exp_imag='file1.im/file2.re' | Pad extend=1 n2=%s > %s" % (ntraces,filtname)
    f8="Rm junk_*.H"
    cmdF="%s; %s; %s; %s; %s; %s" % (f3,f4,f5,f6,f7,f8)
    print(cmdF)
    commands.getstatusoutput(cmdF)

    # # Apply filter
    # a1="< %s | Rtoc | Pad n1out=0 | Ft3d sign1=-1 center1=0 > obs_fft%d.H" % (nodeId)
    # a2="< %s > temp_syn%d.H" % (nodeId)
    # a4="Math file1=obs_fft%d.H file2=%s exp_real='file1.re*file2.re-file1.im*file2.im' exp_imag='file1.re*file2.im+file1.im*file2.re' | Ft3d sign1=1 center1=0 | Real | Window3d n1=`Get < %s n1 parform=n` > %s" % (nodeId,filtname)
    # cmdA="%s; %s; %s;" % (a1,a2,a4)
    # commands.getstatusoutput(cmdA)











    # ix=x[ii]
    # iy=y[ii]
    # cmd1="Window3d synch=1 n3=1 n4=1 f3=%d f4=%d gff=%s/obs%d.h@@@@ hff=%s/obs%d.h@@ < %s > %s/obs%d.h ; echo 'gff=-1' >> %s/obs%d.h " % (iy,ix,writepath,ii,writepath,ii,obsfile,writepath,ii,writepath,ii)
    # cmd2="Window3d synch=1 n3=1 n4=1 f3=%d f4=%d gff=%s/syn%d.h@@@@ hff=%s/syn%d.h@@ < %s > %s/syn%d.h ; echo 'gff=-1' >> %s/syn%d.h " % (iy,ix,writepath,ii,writepath,ii,synfile,writepath,ii,writepath,ii)
    # cmd="%s; %s" % (cmd1, cmd2)
    # print(cmd)
    # cmdcheck="echo '%s' >> %s/grablog.txt" % (percentcmd,writepath)
    # commands.getstatusoutput(cmdcheck)
    # commands.getstatusoutput(cmd)
    # n2size="Get < %s/syn%d.h@@ n2 parform=n" % (writepath,ii)
    # print(n2size)
    # stat1,n2=commands.getstatusoutput(n2size)


# # Only look at locations where a shot falls in a bin
# data2d=sep2npy.sep_read_scratch(foldmap)
# x,y=np.where( data2d > 0.0 )


# # Get the number of time samples
# n1size="Get < %s n1 parform=n" % (synfile)
# stat1,n1=commands.getstatusoutput(n1size)

# fhi=15.0
# flo=1.0
# tmute=0.25

# print(len(x))








