# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
#
#   PROGRAM GRABS SHOT GATHERS AND DOES PROCESSING ON THEM
#
# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


#!/usr/local/bin/python
import sys
import os
import math
import commands
import sepbase
import sep2npy
import numpy as np


# Read the inputs
if len(sys.argv) < 2:
    print('Error: Not enough input args')
    sys.exit()
foldmap = sys.argv[1]
synfile = sys.argv[2]
obsfile = sys.argv[3]
writepath = sys.argv[4]
outputFileName = sys.argv[5]


# Only look at locations where a shot falls in a bin
data2d=sep2npy.sep_read_scratch(foldmap)
x,y=np.where( data2d > 0.0 )


# Get the number of time samples
n1size="Get < %s n1 parform=n" % (synfile)
stat1,n1=commands.getstatusoutput(n1size)

fhi=15.0
flo=1.0
tmute=0.25

print(len(x))

# Visit each location to grab the binned shot data
for ii in range(0,len(x)):
    print("----------------------------------------")
    percent=100.0*ii/len(x)
    percentcmd="percent done:  %f " % (percent)
    print(percentcmd)
    ix=x[ii]
    iy=y[ii]
    cmd1="Window3d synch=1 n3=1 n4=1 f3=%d f4=%d gff=%s/obs%d.h@@@@ hff=%s/obs%d.h@@ < %s > %s/obs%d.h ; echo 'gff=-1' >> %s/obs%d.h " % (iy,ix,writepath,ii,writepath,ii,obsfile,writepath,ii,writepath,ii)
    cmd2="Window3d synch=1 n3=1 n4=1 f3=%d f4=%d gff=%s/syn%d.h@@@@ hff=%s/syn%d.h@@ < %s > %s/syn%d.h ; echo 'gff=-1' >> %s/syn%d.h " % (iy,ix,writepath,ii,writepath,ii,synfile,writepath,ii,writepath,ii)
    cmd="%s; %s" % (cmd1, cmd2)
    print(cmd)
    cmdcheck="echo '%s' >> %s/grablog.txt" % (percentcmd,writepath)
    commands.getstatusoutput(cmdcheck)
    commands.getstatusoutput(cmd)
    n2size="Get < %s/syn%d.h@@ n2 parform=n" % (writepath,ii)
    print(n2size)
    stat1,n2=commands.getstatusoutput(n2size)




    # # Do the wavelet shaping
    # cmd1a=" < %s/syn%d.h Rtoc | Pad maxsize=10000 n1out=0 | Ft3d sign1=-1 center1=0 > %s/syn_fft.H hff=%s/syn_fft.H@@ " % (writepath,ii,writepath,writepath)
    # print(cmd1a)
    # commands.getoutput(cmd1a)
    # # cmd2a="Window3d <%s/debubbleBpMuted_obs%s.h | Rtoc | Pad n1out=0 | Ft3d sign1=-1 center1=0 > %s/obs_fft.H" % (writepath,ii,writepath)
    # cmd2a=" < %s/obs%d.h Rtoc | Pad maxsize=10000 n1out=0 | Ft3d sign1=-1 center1=0 > %s/obs_fft.H hff=%s/obs_fft.H@@" % (writepath,ii,writepath,writepath)
    # print(cmd2a)
    # commands.getoutput(cmd2a)
    # cmd3a="Math file1=%s/syn_fft.H file2=%s/obs_fft.H exp_real='(file1.re*file2.re+file1.im*file2.im)' exp_imag='(file1.im*file2.re-file1.re*file2.im)' | Stack3d maxsize=10000 > %s/junk_numerator.H hff=%s/junk_numerator.H@@" % (writepath,writepath,writepath,writepath)
    # print(cmd3a)
    # commands.getoutput(cmd3a)
    # cmd4a="Math file1=%s/obs_fft.H file2=%s/obs_fft.H exp_real='(file2.re*file2.re+file2.im*file2.im+0.000000000000000000000001)' exp_imag='file2.im*0.0' | Stack3d maxsize=10000 > %s/junk_denom.H hff=%s/junk_denom.H" % (writepath,writepath,writepath,writepath)
    # print(cmd4a)
    # commands.getoutput(cmd4a)
    # cmd5a="Math file1=%s/junk_numerator.H file2=%s/junk_denom.H exp_real='file1.re/file2.re' exp_imag='file1.im/file2.re' | Pad maxsize=10000 extend=1 n2=%s > %s/filter%s.h hff=%s/filter%s.h@@" % (writepath,writepath,n2,writepath,ii,writepath,ii)
    # print(cmd5a)
    # commands.getoutput(cmd5a)  
    # cmdApply="Math file1=%s/obs_fft.H file2=%s/filter%s.h exp_real='file1.re*file2.re-file1.im*file2.im' \
    # exp_imag='file1.re*file2.im+file1.im*file2.re' | Ft3d sign1=1 center1=0 | Real | Window3d n1=%s hff=%s/corrected%s.h@@ > %s/corrected%s.h hff=%s/corrected%s.h@@" %(writepath,writepath,ii,n1,writepath,ii,writepath,ii,writepath,ii)
    # print(cmdApply)
    # commands.getoutput(cmdApply)







    # # Do Debubble, then bandpass and muting of the shot gathers
    # getoffset="Window3d n1=1 f1=7 < `Get parform=n hff < %s/obs%d.h` > %s/offset%s.h" % (ii,ii)
    # print(getoffset)
    # commands.getoutput(getoffset)
    # debuble="../Bin/Debubble_moving.x offset=%s/offset%s.h window=window.h maxoff= nw=250 vel=1500.0 t0=0.6 niter=50 < %s/obs%d.h > %s/debubble_obs%s.h" % (ii,ii,ii)
    # print(debuble)
    # commands.getoutput(debuble)
    # bandpass="Bandpass flo=%s fhi=%s < %s/debubble_obs%s.h > %s/debubbleBp_obs%s.h hff=%s/debubbleBp_obs%s.h@@" % (flo,fhi,ii,ii,ii)
    # print(bandpass)
    # commands.getoutput(bandpass)
    # mute="Mute vmute=0.0 tmute=%s < %s/debubbleBp_obs%s.h > %s/debubbleBpMuted_obs%s.h" % (tmute,ii,ii)
    # print(mute)
    # commands.getoutput(mute)

